/*
 File: wysuwygOverlay.js
 Copyright: Rahul Singh
 Mail: induscrypt@gmail.com
 Source: http://wysuwyg.mozdev.org
 Referenced by: wysuwygOverlay.xul
 Description: The javascript that contains backend code for the overlay
 			Launches the html page containing the main editor
 			Listens for menu and contect meu commands
 			Provides tolerance for immature closing of source window etc.
 			Provides functilonality for dealing with tabs
 Acknowledgements: Functions openXinhaWin  and initOverlay borrow heavily 
 			from Xinha Here! by Jayson Harshbarger at hypercubed.com			

*/



var wyspref_tabenabled=true;
var wyspref_sdbarenabled=true;
var wyspref_histenbled=true;
var wyspref_winontop=true;
var wyspref_referenabled=true;
var wyspref_debugenabled=true;




//a class that will hold all the functions
//and data for the Overlay

var hello = {
 
col :null, 
ta : null,
ta_html : null,
ta_url : null,
ta_doc : null,  //current document
ta_doc_tab : null, //browser tab with current doc 
STL : null, // sourceTabList
editor_tab:null,
ta_flag:false, //is a textarea focused? also it shouldn't be a browser's TA
	
	openXinhaWin : function ()
	{
	
	
	//this.col= window.document.bgColor; 
	this.ta = document.commandDispatcher.focusedElement;
	
	//this.ta_flag = ((this.ta !=null) && (this.ta_url.search(/(^http:\/\/)|(^file:\/\/)/)!=-1) ) ;
	this.ta_flag = ((this.ta !=null) && (this.ta.ownerDocument.URL !=null));
	//alert ( " "+ this.ta_flag);
	if (this.ta_flag )
	{
	this.ta_html = this.ta.value;		
	this.ta_doc = gBrowser.contentDocument;
	this.ta_url = gBrowser.contentDocument.URL;	 
	this.ta_doc_tab=gBrowser.selectedTab ;
	
	
	}
	//nxt 2 lines copied from xinhaHere
	var winontop=wyspref_winontop?'yes':'no';	
	
	var e_par = "toolbar=no,menubar=no,personalbar=no,width=800,height=660, alwaysRaised="+winontop+"," 
				+"centerscreen=yes ,scrollbars=no,resizable=yes,dependent=no,chrome=no modal=no" ;	
	var e_win = window.open("chrome://wysuwyg/content/EditorPageWindowed.html", "editor_xul", e_par);
	
	if (e_win==null){alert('Sorry! Editor window could not be launched.\nAre you using a pop-up blocker?');return;}
	//else
	if (wyspref_histenbled && this.ta_flag )
	wysHistory.saveEntry( this.ta_doc.title,this.ta_url,(new Date()).toString() );	
		
	}, //end function
	
	
	
	
	//reInventing a Tabbed Wheel
	
	
	
	openXinhaTab : function (pagecode)
	{
	
	if(!wyspref_tabenabled){alert("Feature Disabled!\n Please Change Preferences for wySUwyg"); return;}
	
	//hello.STL= sourceTabList.removeInvalidEdTab (hello.STL);
	if ((hello.STL !=null) && (sourceTabList.tabcount == sourceTabList.MAXTABS) )
		{alert("Sorry, no more than "+ sourceTabList.MAXTABS +" wySUwyg tabs allowed! ");return;}
	
	//this.ta_url=null; //flush url, the event-based system picks old statics!!
	this.ta = document.commandDispatcher.focusedElement;
	
	//this.ta_flag = ((this.ta !=null) && (this.ta_url.search(/(^http:\/\/)|(^file:\/\/)/)!=-1) ) ;
	this.ta_flag = ((this.ta !=null) && (this.ta.ownerDocument.URL !=null));
	
	//check if user is already editing this document
	var tmpTab = sourceTabList.findTab1(gBrowser.selectedBrowser,hello.STL);
	if (tmpTab != null )
		{	// OK, the 'browser' is same, now check if the source doc is also the same
			// A User might be reusing a source Tab bfefore submitting from ed. Let him
			if (gBrowser.selectedBrowser.contentDocument !=tmpTab.doc)
				{hello.STL=sourceTabList.removeTab(tmpTab,hello.STL); }
			else		
				{
				  //alert("You are already editing this document!");
				  var res=confirm("You are already editing this document! \n Click OK to go to editor");
				  if (res) gBrowser.selectedTab =tmpTab.edtab;
				  return;
				  }
		}
	
	if (this.ta_flag)
	 	{
	 	this.ta_html = this.ta.value;
	 	this.ta_doc = gBrowser.contentDocument;
	 	this.ta_url = gBrowser.contentDocument.URL;	 
	 	this.ta_doc_tab=gBrowser.selectedTab ;
	 	//alert("bgcolor=  "+ this.col );
	 	}
	
	
	//var editor_tab=null;
	//var editor_doc=null;
	if ( (pagecode!=null) &&(pagecode==1) )
	 this.editor_tab = gBrowser.addTab("chrome://wysuwyg/content/EditorPage_XinhaFull.html");	
	else
	 this.editor_tab = gBrowser.addTab("chrome://wysuwyg/content/EditorPageTabbed.html");

	document.addEventListener("ExtTalkEventGet", this.myTabListener , false );//at start
	document.addEventListener("ExtTalkEventSet", this.myTabListener , false );//at end
	
	gBrowser.selectedTab =this.editor_tab;
	
	if(wyspref_histenbled && this.ta_flag)
	wysHistory.saveEntry( this.ta_doc.title,this.ta_url,(new Date()).toString() );
	
	},//end function

 
 
 
 // On submitting from the editor, check if the original window->tab->document 
 //is still available (this function is for  Windowed mode only)
 checkSourceDoc: function (){
  //check if the tab is still available and still has the same document  
   try{
   gBrowser.selectedTab=this.ta_doc_tab ;
   var nowdoc= gBrowser.contentDocument;
   if (nowdoc!=this.ta_doc) return false;
   else return true;
   }catch (ex){return false;} 
  
  },
  
 //Same thing for tabbed mode--it uses static vars because of event mechanism
 //This has to remove tabs from list as well, so let it do everything
 
 submitFromTab : function (tst,e){
    
   	try{
   		//first see if it's on the list
   		var tb = sourceTabList.findTab(tst,hello.STL);
   		if (tb==null) return false;
   		
   		//else
   		gBrowser.selectedTab= tb.tab;  //throws up if tab closed, else brings to front
   		var nowdoc= gBrowser.contentDocument;
   		if (nowdoc!=tb.doc)
   		{//now this tab is useless for us
   		gBrowser.selectedTab =tb.edtab ;
   		hello.STL=sourceTabList.removeTab(tb,hello.STL) ;
   		tb=null; //destroy useless tab
   		return false;}
   		else
   		{
   		//do the real thing
   		t=tb.tarea;
   		t.value=e.target.getAttribute("att_sourceTAtxt");
   		//e.target.setAttribute("att_success", 1); //rahul-is it still needed?
   		
   		//stop listening, else memleak
   		//this.window.document.removeEventListener("ExtTalkEventGet", this.myTabListener , false );//at start
		//this.window.document.removeEventListener("ExtTalkEventSet", this.myTabListener , false );//at end
   		
   		
   		//done? Now close the editor (as the page cannot close itself)
   		gBrowser.removeTab(tb.edtab);
   		
   		return true;}
   	 }catch (ex){ if(wyspref_debugenabled)alert (ex.message);return false;}
  
  },


	//Capture custom event from a page opened in a tab

 myTabListener: function (e) {
	// -- TO DO : Check if opened by wySUwyg only -- //
	
	try{
	
	var elem=e.target;
  	var req=elem.getAttribute("att_mode") ; //what is the request? 	
    	
  		//now, set the values for the attributes for that element
  		if (req=='getData')
  		{  	
  			if (!hello.ta_flag ) return;
  			
  			//else
  			
  			//ok, this static looking affair is messy, but this=source, so no 'this'
  			elem.setAttribute("att_sourceURL", hello.ta_url);
  			elem.setAttribute("att_sourceTAtxt", hello.ta_html);
  			
  			//the timestamp is the unique id shared between
  			//the element on the page and the data in the tablist
  			var tstamp=(new Date()).getTime();
  			elem.setAttribute("att_timestamp", tstamp);
  			
  			//now create tabElement for the tablist
  			brEd=gBrowser.getBrowserForTab(hello.editor_tab);
  			brSrc=gBrowser.getBrowserForTab(hello.ta_doc_tab);
  			tel= new tabEl(hello.ta_doc_tab,hello.ta_doc,tstamp,hello.ta,hello.editor_tab,brEd,brSrc);
  			
  			//add this element to tablist
  			hello.STL= sourceTabList.addTab(tel,hello.STL); //auto-creates if null list
		 }
  		
  		else if  (req=='setData') //editor is submitting data
  		{
  			var ts=elem.getAttribute("att_timestamp");  		  		
  			if (!hello.submitFromTab(ts,e) )
  				{alert('The original TextBox is no more available!\n Please copy your text');}  			
  		}  		

   }catch (ex) {if(wyspref_debugenabled)alert('Error:in myTabListener \n'+ex.message );}
  	   
},


 //not used, just some debug
 helpVal: function()
 {
     return this.ta.value;
 },
  
  
   
//Every time a tab is removed, check if it was an editor or launcher
//if so,remove it from the tablist  
  checkRemovedTab : function (event)
  { 
    if (!wyspref_tabenabled)return;
    
    //else
  	if (event.relatedNode != gBrowser.mPanelContainer)
  	return;
  	
  	var browser = event.target.childNodes[1];
  	var tb= sourceTabList.findTab1(browser,hello.STL);
  	if (tb!=null)
  	{
  	hello.STL=sourceTabList.removeTab(tb,hello.STL);  	
  	//sourceTabList.traverse(hello.STL);
  	}
  
  },
  
  
  //add referrer to the text if referrer is from SU
  //not using it right now!
  
  /*
  addReferrer : function (referrer)
  {  
     var str="";
     try{
     if (referrer==null)return null;
     if(!wyspref_referenabled) return null;
     //else
     
     var b1=/\.stumbleupon\.com/.test(referrer); 
     var b2=/\/www\.stumbleupon\.com/.test(referrer); 
     if ( b1 && !b2 )
     str="<BR/><font size='1'><a href='"+referrer+"'>"+referrer+"</a></font>";
     
     return str;
    
  	}catch(ex){return null;}
  
  },

*/
	
  initOverlay: function() {
  	var menu = document.getElementById("contentAreaContextMenu");
  	menu.addEventListener("popupshowing", hello.contextPopupShowing, false);
  	
  	var container = gBrowser.mPanelContainer;
	container.addEventListener("DOMNodeRemoved", hello.checkRemovedTab, false);	
	
	loadPrefs();
	
	//init history
	if (wyspref_histenbled) 
		startHist(null,wyspref_debugenabled) ;	
  	
  },
	
	// show context menu only for textarea
	contextPopupShowing: function()
	{
  	gContextMenu.showItem("men_wysuwyg", gContextMenu.onTextInput);
  	//gContextMenu.showItem("men_sribble2", gContextMenu.onTextInput);	
    },  
  
  
cleanOverlay: function  ()
{
	//stop listening, else memleak
	//here this=overlay
   		this.window.document.removeEventListener("ExtTalkEventGet", this.myTabListener , false );//at start
		this.window.document.removeEventListener("ExtTalkEventSet", this.myTabListener , false );//at end
},
  
} //end hello


function openSidebar()
{   
	if(!wyspref_sdbarenabled){alert("Feature Disabled!\n Please Change Preferences for wySUwyg"); return;}
	//else
	var url="chrome://wysuwyg/content/wysuwyg_dragdrop.xul";
	var sidebar = document.getElementById('nameofSidebar')
	sidebar.setAttribute('sidebarurl',url);
	
	//sidebar.setAttribute('sidebartitle',"hello");
	toggleSidebar('nameofSidebar');
}


function openPrefWindow()
{

	var prefwin="chrome://wysuwyg/content/wysuwyg_prefwin.xul";
	window.openDialog(prefwin, "wySUwygPreferences", "chrome,modal,dialog,centerscreen,dependent");

}

function openWysHistory ()
{

	if(!wyspref_histenbled){alert("Feature Disabled!\n Please Change Preferences for wySUwyg"); return;}
	
	//else
	var histtab="chrome://wysuwyg/content/wysuwyg_history.xul";
	
	gBrowser.selectedTab=gBrowser.addTab(histtab);
}


function loadPrefs()
{
	 try{
 	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch);   
        
      wyspref_tabenabled = prefs.getBoolPref("wysuwyg.newfeatures.tabenabled");   
	  wyspref_sdbarenabled = prefs.getBoolPref("wysuwyg.newfeatures.sidebarenabled");   
	  wyspref_histenbled = prefs.getBoolPref("wysuwyg.newfeatures.histenabled");   
	  wyspref_winontop = prefs.getBoolPref("wysuwyg.newfeatures.winontop");   
	  wyspref_referenabled = prefs.getBoolPref("wysuwyg.newfeatures.referenabled");   
	  wyspref_debugenabled = prefs.getBoolPref("wysuwyg.newfeatures.debugenabled"); 
    
	}catch (ex) {/* Browser startup, Die Silently */}
}





//document.addEventListener("ExtTalkEvent", this.myTabListener, false, true);
window.addEventListener("load", hello.initOverlay, false);

window.addEventListener("unload", hello.cleanOverlay, false);


