/*
 File: tabLst.js
 Copyright: Rahul Singh
 Mail: induscrypt@gmail.com
 Source: http://wysuwyg.mozdev.org
 Referenced by: wysuwygOverlay.xul
 Description: A Linked List of Custom "tab Elements" (a misnomer!)
 			Each tabEL contains relevant information about sets of tabs
 			relevant to each launch of wySUwyg editor in tabbed mode

*/


var sourceTabList = {

MAXTABS: 6, //Max number of editors allowed
tabcount : 0, //no of elements in the list 


//add-easier at beginning
//paramenter- a tab , start of list
//retirns - start of list, i.e. te
  addTab : function (te, lst)
{
    
    //if(lst==null)alert("Creating new list");
   	te.nxt=lst;
   	lst=te;
   	
   	sourceTabList.tabcount++;
   	return lst;
},

//remove a tab 

removeTab : function (te,lst)
{
 	var prev=lst; 
 	var temp=lst;
 	try{
 	
 		if (te==lst) //remove first  item
 		{lst=te.nxt;te=null;sourceTabList.tabcount--; return lst;}
 		
 		while (temp!=te)
 		{
 		//document.write("<br> X <br>") ;
 		
 		if (temp.nxt==null)//reached end, no matching tab found
 		{return lst; }
 		
 		//else
 		prev=temp;
 		temp=temp.nxt;
 		}
 		
 		prev.nxt=temp.nxt;
 		temp=null;
 		sourceTabList.tabcount--;
 		//alert('removed tab, left '+sourceTabList.tabcount)
 		return lst;
 	
 	}catch(ex){if(wyspref_debugenabled)alert(ex.message);return lst;}
},


//find tab based on ID
//returns matching tabEl or null

findTab : function (id,lst)
{
	 var temp=lst; 
	 while (temp!=null)
	 {
	 if (temp.timestamp==id) return temp;
	 //else
	 temp=temp.nxt;
	 }
	 
	 return null; //not found

},


//find a tab corresponding to a a browser


findTab1 : function (br,lst)
{
	 var temp=lst; 
	 while (temp!=null)
	 {
	
	if ( (temp.bred==br) || (temp.brsrc==br)  )
	 {return temp;}
	
	 //else
	 temp=temp.nxt;
	 }
	 
	 return null; //not found

},






//traverse, only  for debugging
traverse : function (lst)
{

 	var temp=lst; 
 	var str="on list: ";
 	while (temp!=null)
 	{
 	//document.write(temp.doc + "<br>");
 	str = str + temp.timestamp + "\n" ;
 	temp=temp.nxt;
 	}
 	
 	if(wyspref_debugenabled)alert(str);
 	
},

}// end class


//The actual elsement of a list
//has a tab's data and a pointer to the next el in the list
//constructor
 function tabEl (tb,dc,ts,ta,et,bre,brs)
 {
 	this.tab=tb;
 	this.doc=dc;
 	this.timestamp=ts; 
 	this.tarea=ta;
 	this.edtab=et;
 	this.bred=bre;
 	this.brsrc=brs;
 	this.nxt=null;
 }
 



//TEST CODE, NOW NEEDS CHANGE :-)
/*

te1= new tabEl("1tb","1dc","1ts");
te2= new tabEl("2tb","2dc","2ts");
te3= new tabEl("3tb","3dc","3ts");


stl= null;
stl= sourceTabList.addTab(te1,null);
stl= sourceTabList.addTab(te2,stl);
stl= sourceTabList.addTab(te3,stl);

sourceTabList.traverse(stl);
document.write("<br> sourceTabList.tabcount= " + sourceTabList.tabcount +"<br>");

sourceTabList.findTab("1ts",stl) !=null ? document.write("found "): document.write("NO found");

stl= sourceTabList.removeTab(te2,stl);	
sourceTabList.traverse(stl);
document.write("<br> sourceTabList.tabcount= " + sourceTabList.tabcount +"<br>");
sourceTabList.findTab("2ts",stl) !=null ? document.write("found "): document.write("NO found");

stl= sourceTabList.removeTab(te1,stl);	
sourceTabList.traverse(stl);
document.write("<br> sourceTabList.tabcount= " + sourceTabList.tabcount +"<br>");

document.write("<br> --- Removed item?  " + te2.doc +"<br>")


*/
	
