
     /*  -----------------------------------------------------------------------
     --  This file is a part of wySUwyg extension for Gecko based browsers
     --  This is the script that loads Xinha the tabbed version of wySUwyg
     --  Referenced By: EditorPageTabbed.html
     --	********************************************************
	 -- Copyright: Rahul Singh             
	 -- Mail: induscrypt@gmail.com                              
	 -- Web : http://wySUwyg.mozdev.org        

     -------------------------------------------------------------------------  */
     
     
     
     
     
     /*
     This block has all the code that embeds Xinha
     //on loading the doc it calls  a function xinha_init
     //defined inline, that places a blank xinha_editor
     //on the page
     */
     
     
     xinha_editors = null;
     xinha_init    = null;
     xinha_config  = null;
     xinha_plugins = null;
     
     // This contains the names of textareas we will make into Xinha editors
     xinha_init = xinha_init ? xinha_init : function()
     {
     /** STEP 1 ***************************************************************
     * First, what are the plugins you will be using in the editors on this
     * page.  List all the plugins you will need, even if not all the editors
     * will use all the plugins.
     ************************************************************************/
     
     xinha_plugins = xinha_plugins ? xinha_plugins :
     [
     'CharacterMap',
     'CharCounter',
     'ContextMenu',
     'DoubleClick',     
     'FindReplace',
     'FullScreen',
     //'FullPage',
      'ListType',
     //'GetHtml',
     'InsertAnchor',
     'InsertWords', 
     'QuickTag',
     'IndusCenter',
     'IndusPre',
     'Stylist'
     ];
     // THIS BIT OF JAVASCRIPT LOADS THE PLUGINS, NO TOUCHING  :)
     if(!HTMLArea.loadPlugins(xinha_plugins, xinha_init)) return;
     
     /** STEP 2 ***************************************************************
     * Now, what are the names of the textareas you will be turning into
     * editors?
     ************************************************************************/
     
     xinha_editors = xinha_editors ? xinha_editors :
     [
     'myTextArea'
     ];
     
     /** STEP 3 ***************************************************************
     * We create a default configuration to be used by all the editors.
     * If you wish to configure some of the editors differently this will be
     * done in step 4.
     *
     * If you want to modify the default config you might do something like this.
     *
     *   xinha_config = new HTMLArea.Config();
     *   xinha_config.width  = 640;
     *   xinha_config.height = 420;
     *
     *************************************************************************/
     
     xinha_config = xinha_config ? xinha_config : new HTMLArea.Config();
     
     xinha_config.width  = 728;
     xinha_config.height = 500;
     xinha_config.mozParaHandler = 'built-in'; //This gets you br's insted of p's
     
     //the drop down:--goes phut!
     /*
     xinha_config.formatblock = {
     "&mdash; format &mdash;"  : "",
     "Code" : "code",
     "Bold" : "b",
     "Center" : "center",
     "Address"  : "address",
     "Formatted": "pre"
     };
     */
     
     //Add fonts to drop down
     xinha_config.fontname = wys_xinha_fontlist
     
     
     //Multiline Toolbar!
     xinha_config.flowToolbars = false  ;
     
     
     
     //start custom button
     //Interesting, but not needed
      
      /*     
     xinha_config.registerButton({
      	id       : "indus-test",      // the ID of your button
       	tooltip  : "Do test",    // the tooltip
       	image    : "test.gif",
       				//"['ed_buttons_main.gif',2,3]",  // image to be displayed in the toolbar
       				//editor.imgURL("ed_induscenter.gif", "IndusCenter")
       	textMode : false,            // disabled in text mode
       	action   : function(editor) { // called when the button is clicked
                    alert(" wys_xinha_test = "+ wys_xinha_test );
                     wys_xinha_test++;
                  },
      	 context  : "body"               // will be disabled if outside a <p> element
     });
 
     */
 	//end custom button    
 	
 	
 	
 	//start insertword configuration
 	
 	
 	if(typeof InsertWords != 'undefined')  
  	  	 	    {  
  	  	 	      // Register the keyword/replacement list  
  	  	 	      var keywrds1 = new Object();  
  	  	 	      //var keywrds2 = new Object();  
  	  	 	 
  	  	 	      keywrds1['-- Insert Word --'] = '';  
  	  	 	      keywrds1['Copyright'] = '&copy; ';  
  	  		      keywrds1['Via'] = '::via.:';  
  	  	 	      keywrds1['Image'] = 'Image Source: '; 
  	  	 	      keywrds1['Contact'] = 'Contact: ';
  	  	 	      keywrds1['Website'] = 'Website: ';
  	  	 	      keywrds1['Email'] = 'Email: ';
  	  	 	 	/*		
  	  	 	      keywrds2['-- Insert Keyword --'] = '';  
  	  	 	      keywrds2['Username'] = '%user%';  
  	  	 	      keywrds2['Last login date'] = '%last_login%';  
  	  	 	     */ 
  	  	 	      xinha_config.InsertWords = {  
  	  	 	        /*
  	  	 	        combos : [ { options: keywrds1, context: "body" },
  	  	 	               { options: keywrds2, context: "li" } ] 
  	  	 	        */ 
  	  	 	        
  	  	 	        combos : [ { options: keywrds1, context: "body" } ]
  	  	 	      }  
  	  	 	 
  	  	 	    } 	
 	
 	//end insertword configuration
 	
     
     
     //config the toolbar:
     xinha_config.toolbar =
     [
     ["popupeditor"],
     ["separator","fontname","fontsize"],     
     ["separator","htmlmode"],		//,"indus-test"
     ["separator","insertorderedlist","insertunorderedlist"],
     ["separator","showhelp","about"],
     ["linebreak","bold","italic","underline","strikethrough"], //"indus-hilite"
     ["separator","forecolor","hilitecolor", "textindicator"],     
     ["separator","createlink","insertimage"],
     ["separator","undo","redo","selectall","print"], (HTMLArea.is_gecko ? [] : ["cut","copy","paste","overwrite","saveas"]),
     ["separator","killword","clearfonts","removeformat"],
     ];
     
     //styles to be loaded in the stylist
     
     xinha_config.stylistLoadStyles('body.teal_style { background-color:teal; color:#bbbbbb; font-size: 13px;	font-family: arial,helvetica;  }', {'body.teal_style' : 'Teal'});
     xinha_config.stylistLoadStyles('body.darkteal_style { background-color:#004040; color:#bbbbbb; font-size: 13px;	font-family: arial,helvetica;  }', {'body.darkteal_style' : 'Dark Teal'});
     xinha_config.stylistLoadStyles('body.green_style { background-color:#307030; color:#eeeeee; font-size: 13px;	font-family: arial,helvetica; }', {'body.green_style' : 'Green'});
     xinha_config.stylistLoadStyles('body.darkgreen_style { background-color:#044604; color:#cccccc; font-size: 13px;	font-family: arial,helvetica; }', {'body.darkgreen_style' : 'Dark Green'});
     xinha_config.stylistLoadStyles('body.red_style { background-color:802c2c; color:##dddddd; font-size: 13px;	font-family: arial,helvetica; }', {'body.red_style' : 'Red'});
     xinha_config.stylistLoadStyles('body.darkred_style { background-color:#551a1a; color:#cccccc; font-size: 13px;	font-family: arial,helvetica; }', {'body.darkred_style' : 'Dark Red'});
     xinha_config.stylistLoadStyles('body.orange_style { color:#eeeeee; background-color: #aa7733; font-size: 13px;	font-family: arial,helvetica; }', {'body.orange_style' : 'Orange'});
     xinha_config.stylistLoadStyles('body.brown_style { color:#dddddd;background-color: #825511; font-size: 13px;	font-family: arial,helvetica; }', {'body.brown_style' : 'Brown'});
     xinha_config.stylistLoadStyles('body.darkyellow_style { color:#eeeeee; background-color: #70702a; font-size: 13px;	font-family: arial,helvetica; }', {'body.darkyellow_style' : 'Dark Yellow'});
     xinha_config.stylistLoadStyles('body.blue_style { color:#dddddd; background-color: #2d2d6c; font-size: 13px;	font-family: arial,helvetica; }', {'body.blue_style' : 'Blue'});
     xinha_config.stylistLoadStyles('body.navy_style { background-color:#2a2a50; color:#dddddd; font-size: 13px;	font-family: arial,helvetica; }', {'body.navy_style' : 'Navy'});
     xinha_config.stylistLoadStyles('body.purple_style { background-color:723072; color:#dddddd; font-size: 13px;	font-family: arial,helvetica; }', {'body.purple_style' : 'Purple'});
     xinha_config.stylistLoadStyles('body.darkpurple_style { color:#cccccc; background-color: #400a40; font-size: 13px;	font-family: arial,helvetica; }', {'body.darkpurple_style' : 'Dark Purple'});
     xinha_config.stylistLoadStyles('body.darkgrey_style { color:#cccccc;	background-color: #3a3a3a; font-size: 13px;	font-family: arial,helvetica; }', {'body.darkgrey_style' : 'Dark Grey'});
     xinha_config.stylistLoadStyles('body.grey_style { color:#eeeeee;	background-color: #626262; font-size: 13px;	font-family: arial,helvetica; }', {'body.grey_style' : 'Grey'});
     xinha_config.stylistLoadStyles('body.lightgrey_style { background-color:#999999; color:#222222; font-size: 13px;	font-family: arial,helvetica; }', {'body.lightgrey_style' : 'Light Grey'});
     xinha_config.stylistLoadStyles('body.lightergrey_style {color:#222222;	background-color: #999999; font-size: 13px;	font-family: arial,helvetica; }', {'body.lightergrey_style' : 'Lighter Grey'});
     xinha_config.stylistLoadStyles('body.lightestgrey_style { color:#333333; background-color: #ffffff; font-size: 13px;	font-family: arial,helvetica; }', {'body.lightestgrey_style' : 'Lightest Grey'});
     xinha_config.stylistLoadStyles('body.black_style { color:#dddddd; background-color: #222222; font-size: 13px;	font-family: arial,helvetica; }', {'body.black_style' : 'Black'});
     
     
     
     
     /** STEP 3 ***************************************************************
     * We first create editors for the textareas.
     *
     * You can do this in two ways, either
     *
     *   xinha_editors   = HTMLArea.makeEditors(xinha_editors, xinha_config, xinha_plugins);
     *
     * if you want all the editor objects to use the same set of plugins, OR;
     *
     *   xinha_editors = HTMLArea.makeEditors(xinha_editors, xinha_config);
     *   xinha_editors['myTextArea'].registerPlugins(['Stylist','FullScreen']);
     *   xinha_editors['anotherOne'].registerPlugins(['CSS','SuperClean']);
     *
     * if you want to use a different set of plugins for one or more of the
     * editors.
     ************************************************************************/
     
     xinha_editors   = HTMLArea.makeEditors(xinha_editors, xinha_config, xinha_plugins);
     
     /** STEP 4 ***************************************************************
     * If you want to change the configuration variables of any of the
     * editors,  this is the place to do that, for example you might want to
     * change the width and height of one of the editors, like this...
     *
     *   xinha_editors.myTextArea.config.width  = 640;
     *   xinha_editors.myTextArea.config.height = 480;
     *
     ************************************************************************/
     
     
     
     /** STEP 5 ***************************************************************
     * Finally we "start" the editors, this turns the textareas into
     * Xinha editors.
     ************************************************************************/
     
     HTMLArea.startEditors(xinha_editors);
     
     
     
     
     //again copied this line from xinha! Here
    // window.setTimeout("xinha_editors['myTextArea'].whenDocReady(this.initFromOverlay())",1500);
    	xinha_editors['myTextArea'].whenDocReady(this.initFromOverlay());
    
     	//xinha_editors['myTextArea'].whenDocReady(this.setInitText());
     
   //window.setTimeout("setInitText()",1500);  
     
     window.onload = null;
     }
     
     window.onload   = xinha_init;    
     window.onunload = cleanHouse;
     
     
     
